/*
 * Blackfin FIRtB^R[h Visual DSP++p
 *
 * Copyright(C) 2012 Kaneko System Co., Ltd.
 *
 * Last Update: 2012/08/22
 *
 * yӁz
 * EǂȂłRɉςĎgp邱Ƃł܂B
 * Ẽ\tgEFA͖ۏ؂łB̃t@CɋLڂĂER[h
 *   gpꍇ́A[U̐ӔCɂčsĂB̎gp
 *   NA[U܂͑O҂ɐQɊւAЂ͈؂̐ӔC
 *   ܂B
 *
 */

#include <blackfin.h>
#include <builtins.h>
#include <filter.h>
#include <math.h>
#include <stdint.h>
#include <string.h>

/* TvO_ */
#define NUM_SAMPLES		(1024)

#define NUM_TAPS		(sizeof(sf_fir_coeff) / sizeof(fract16))

/* fract16́Ashorttypedef. ƌŒ菬_̌^Ƌʂ邽߂
 * wb_t@CŒ`Ă.
 */
 
/* fir_fr16֐p̏ԕۑp[Nobt@ */
static fir_state_fr16 sf_fir_state;

/* ̓f[^pobt@(ADC̃f[^) */
static fract16 sf_input[NUM_SAMPLES];

/* FIRo͌ʗpobt@ */
static fract16 sf_output[NUM_SAMPLES];

/* FIRtB^̌W(Scilab̃c[ŌWZoĂ) */
/* TvOg : 16kHz */
/* JbgItg   : 1kHz LPF */
static fract16 sf_fir_coeff[] =
{
	1,
	4,
	10,
	19,
	30,
	39,
	43,
	34,
	8,
	-34,
	-88,
	-138,
	-166,
	-152,
	-83,
	37,
	188,
	329,
	406,
	371,
	197,
	-105,
	-478,
	-822,
	-1009,
	-921,
	-473,
	348,
	1474,
	2756,
	3991,
	4968,
	5506,
	5506,
	4968,
	3991,
	2756,
	1474,
	348,
	-473,
	-921,
	-1009,
	-822,
	-478,
	-105,
	197,
	371,
	406,
	329,
	188,
	37,
	-83,
	-152,
	-166,
	-138,
	-88,
	-34,
	8,
	34,
	43,
	39,
	30,
	19,
	10,
	4,
	1,
};

/* fir_fr16֐p̒x */
static fract16 sf_fir_delay[NUM_TAPS];

/* ̊֐̏ڍׂ́A"Visual DSP++ Help for Blackfin"sin_fr16QƂĂ */
static fract16 s_sin2pi_fr16(fract16 x)
{ 
	if(x < 0x2000)
	{   /* <0.25  */
		/* first quadrant [0../2):               */
		/* sin_fr16([0x0..0x7fff]) = [0..0x7fff)   */
		return sin_fr16(x * 4);
	}
	else if(x == 0x2000)
	{
		/* = 0.25 */
		return 0x7fff;
	}
	else if (x < 0x6000)
	{
		/* < 0.75  */
		/* if (x < 0x4000)                         */
		/* second quadrant [/2..):             */
		/* -sin_fr16([0x8000..0x0)) = [0x7fff..0)  */
		/*                                         */
		/* if (x < 0x6000)                         */
		/* third quadrant [..3/2):             */
		/* -sin_fr16([0x0..0x7fff]) = [0..0x8000)  */
		return -sin_fr16((0xc000 + x) * 4);
	}
	else
	{
		/* fourth quadrant [3/2..):            */
		/* sin_fr16([0x8000..0x0)) = [0x8000..0)   */
		return sin_fr16((0x8000 + x) * 4);
	}
}


void main(void)
{
	int32_t l_lc;
	
	/* sf_fir_statȅ(fir_init̓}N֐) */
	fir_init(sf_fir_state, sf_fir_coeff, sf_fir_delay, NUM_TAPS, 0);
	
	/* x[NA */
	memset(sf_fir_delay, 0, sizeof(sf_fir_delay));
	
	/* Kɓ̓f[^쐬
	 * ƂāATvO[g16kHzA1kHz3kHz̐g`
	 */
	for(l_lc = 0; l_lc < NUM_SAMPLES; l_lc++)
	{
		sf_input[l_lc] = (s_sin2pi_fr16((l_lc * 2048) & 0x7FFF) / 2) + (s_sin2pi_fr16((l_lc * 6144) & 0x7FFF) / 2);
	}
	
	/* FIRtB^ */
	/* W1kHzLFPȂ̂ŁAsf_outputɂ1kHz̐gcA3kHz̐g`܂. */
	fir_fr16(sf_input, sf_output, NUM_SAMPLES, &sf_fir_state);
}
